﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TESS_5600
{
    public partial class frmScan : Form
    {
        public frmScan()
        {
            InitializeComponent();

            General.g_Common.SetFormBorderStyle(this, System.Windows.Forms.FormBorderStyle.FixedSingle);
            General.g_Common.SetFormStartPosition(this, FormStartPosition.CenterParent);
            General.g_Common.SetFormIcon(this, Properties.Resources.Icon);
            General.g_Common.SetControlText(this, "Scan Sensor");
            General.g_Common.SetFormMinimizeBox(this, false);
            General.g_Common.SetFormMaximizeBox(this, false);
        }

        public void ScanDut()
        {
            General.g_Common.SetControlCursor(this, Cursors.WaitCursor);
            General.g_IsUserTerminate = false;
            General.g_IsChangeMeasureRate = false;

            string[] strRespondData = { };
            bool bolValue = frmTest.OpenDongle(out strRespondData);
            General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
            General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);

            if (bolValue)
            {
                string[] strSensorsData = { };
                frmTest.ScanSensor(10, out strSensorsData, out strRespondData);
                General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);

                General.g_Common.SetCheckedListBoxItemsAddRange(this.ckbSensor, strSensorsData);
            }
            General.g_Common.SetControlCursor(this, Cursors.Default);
        }

        private void frmScan_Load(object sender, EventArgs e)
        {
            General.g_Common.SetFormShow(this);
            General.g_Common.SetThreadStart(ScanDut);
        }

        private void frmScan_FormClosing(object sender, FormClosingEventArgs e)
        {
            General.g_Common.SetFormDispose(this);
        }

        private void frmScan_Resize(object sender, EventArgs e)
        {

        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            string strCaption = string.Empty;
            string strMessage = string.Empty;

            string[] strSensorData = General.g_Common.GetCheckedListBoxCheckedItems(this.ckbSensor);
            if (strSensorData.Length ==0)
            {
                if (General.g_Language.ToUpper() == "Chinese".ToUpper())
                {
                    strCaption = "错误";
                    strMessage = "请选择一个传感器！";
                }
                else
                {
                    strCaption = "Error";
                    strMessage = "Please select one sensors!";
                }
                General.g_Common.SetMessageBoxShow(strMessage, strCaption, MessageBoxIcon.Error);
                return;
            }

            if (strSensorData.Length > 5)
            {
                if (General.g_Language.ToUpper() == "Chinese".ToUpper())
                {
                    strCaption = "错误";
                    strMessage = "最多只能选择5个传感器！";
                }
                else
                {
                    strCaption = "Error";
                    strMessage = "Select up to 5 sensors!";
                }
                General.g_Common.SetMessageBoxShow(strMessage, strCaption, MessageBoxIcon.Error);
                return;
            }

            frmTest.l_SensorConnectionInfo = new frmTest.SensorConnectionInfo[strSensorData.Length];
            frmTest.l_SensorMeasureData = new frmTest.SensorMeasureData[strSensorData.Length];

            General.g_Common.SetControlEnabled(this, false);
            General.g_Common.SetControlCursor(this, Cursors.WaitCursor);

            for (int i = 0; i < strSensorData.Length; i++)
            {
                string strValue = strSensorData[i];
                string strRegexString = "MAC:(.+) NAME";
                string strAddress = General.g_Common.GetStringMatch(strValue, strRegexString);
                if (strAddress.Trim() == "")
                {
                    if (General.g_Language.ToUpper() == "Chinese".ToUpper())
                    {
                        strCaption = "错误";
                        strMessage = "被测产品地地址错误，被测产品地址不能为空！";
                    }
                    else
                    {
                        strCaption = "Error";
                        strMessage = "Sensor address error, dut address can't be null!";
                    }
                    General.g_Common.SetMessageBoxShow(strMessage, strCaption, MessageBoxIcon.Error);
                    return;
                }
            }

            bool bolConnection = true;
            string[] strRespondData = { };
            for (int i = 0; i < strSensorData.Length; i++)
            {
                if (frmTest.l_SensorConnectionInfo[i].IsConnect)
                {
                    frmTest.l_SensorConnectionInfo[i].IsConnect = frmTest.DisconnectingSensor(frmTest.l_SensorConnectionInfo[i].ConHandle, out strRespondData);
                    General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                    General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);
                }

                string strValue = strSensorData[i];
                string strRegexString = "MAC:(.+) NAME";
                string strAddress = General.g_Common.GetStringMatch(strValue, strRegexString);
                frmTest.l_SensorConnectionInfo[i].Address = strAddress;

                strRegexString = "NAME:(.+) RSSI";
                string strName = General.g_Common.GetStringMatch(strValue, strRegexString);
                frmTest.l_SensorConnectionInfo[i].Name = strName;

                strRegexString = "RSSI:(.+)";
                string strRssi = General.g_Common.GetStringMatch(strValue, strRegexString);
                frmTest.l_SensorConnectionInfo[i].Rssi = strRssi;

                bool bolStatus = frmTest.ConnectDevice(strAddress, out frmTest.l_SensorConnectionInfo[i].ConHandle, out strRespondData);
                General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);

                //if (!bolStatus)
                //{
                //    string[] strActiveAddress = { };
                //    string[] strActiveHandle = { };
                //    frmTest.DisplayingActiveConnections(out strActiveAddress, out strActiveHandle, out strRespondData);
                //    for (int k = 0; k < strActiveAddress.Length; k++)
                //    {
                //        if (strActiveAddress[k] == frmTest.l_SensorConnectionInfo[i].Address)
                //        {
                //            frmTest.l_SensorConnectionInfo[i].ConHandle = strActiveHandle[k];
                //            bolStatus = true;
                //            break;
                //        }
                //    }
                //}

                frmTest.l_SensorConnectionInfo[i].IsConnect = bolStatus;
                if (!bolStatus)
                {
                    if (General.g_Language.ToUpper() == "Chinese".ToUpper())
                    {
                        strCaption = "错误";
                        strMessage = "传感器：" + strAddress + "连接错误！";
                    }
                    else
                    {
                        strCaption = "Error";
                        strMessage = "Sensor: " + strAddress + " connect error!";
                    }
                    General.g_Common.SetMessageBoxShow(strMessage, strCaption, MessageBoxIcon.Error);
                    bolConnection = false;
                    break;
                }
                else
                {
                    frmTest.l_SensorConnectionInfo[i].DataLogFile = General.g_DataFolderPath + frmTest.l_SensorConnectionInfo[i].Address + "-" + DateTime.Now.ToString("yyyyMMddHHmmss") + ".dat";

                    //get uuid
                    frmTest.GetDeviceCharacteristics(frmTest.l_SensorConnectionInfo[i].Address, out frmTest.l_SensorConnectionInfo[i].Characteristics, out strRespondData);

                    //get initialize value
                    //battery
                    bolStatus = frmTest.GetDeviceBatteryData(i, out frmTest.l_SensorMeasureData[i].BatteryDataHex, out strRespondData);
                    General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                    General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);
                    if (bolStatus)
                    {
                        //battery level
                        frmTest.GetDeviceBatteryLevel(frmTest.l_SensorMeasureData[i].BatteryDataHex, out frmTest.l_SensorMeasureData[i].BatteryLevel);
                    }
                    else
                    {
                        if (General.g_Language.ToUpper() == "Chinese".ToUpper())
                        {
                            strCaption = "错误";
                            strMessage = "获取传感器电池数据错误！";
                        }
                        else
                        {
                            strCaption = "Error";
                            strMessage = "Get sensor battery data error!";
                        }
                        General.g_Common.SetMessageBoxShow(strMessage, strCaption, MessageBoxIcon.Error);
                        bolConnection = false;
                        break;
                    }

                    //measure data
                    for (int n = 0; n < 5; n++)
                    {
                        bolStatus = frmTest.GetDeviceMeasureData(i, out frmTest.l_SensorMeasureData[i].MeasureDataHex, out strRespondData);
                        General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                        General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);

                        if (bolStatus && frmTest.l_SensorMeasureData[i].MeasureDataHex.Length == 28)
                        {
                            break;
                        }
                        else
                        {
                            bolStatus = false;
                        }
                    }

                    if (bolStatus)
                    {
                        //pressure
                        frmTest.GetDevicePressurePsi(frmTest.l_SensorMeasureData[i].MeasureDataHex, out frmTest.l_SensorMeasureData[i].MeasurePressurePsi);
                        frmTest.l_SensorMeasureData[i].MeasurePressureMinPsi = frmTest.l_SensorMeasureData[i].MeasurePressurePsi - 2.0;
                        frmTest.l_SensorMeasureData[i].MeasurePressureMaxPsi = frmTest.l_SensorMeasureData[i].MeasurePressurePsi + 2.0;
                        
                        //pressure range
                        frmTest.GetDevicePressureRangePsi(frmTest.l_SensorMeasureData[i].MeasureDataHex, out frmTest.l_SensorMeasureData[i].MeasurePressureRangeMinPsi, out frmTest.l_SensorMeasureData[i].MeasurePressureRangeMaxPsi);

                        //temperature
                        frmTest.GetDeviceTemperqtureC(frmTest.l_SensorMeasureData[i].MeasureDataHex, out frmTest.l_SensorMeasureData[i].MeasureTemperatureC);
                        frmTest.l_SensorMeasureData[i].MeasureTemperatureMinC = frmTest.l_SensorMeasureData[i].MeasureTemperatureC - 2.0;
                        frmTest.l_SensorMeasureData[i].MeasureTemperatureMaxC = frmTest.l_SensorMeasureData[i].MeasureTemperatureC + 2.0;
                    }
                    else
                    {
                        if (General.g_Language.ToUpper() == "Chinese".ToUpper())
                        {
                            strCaption = "错误";
                            strMessage = "获取传感器压力量程错误！";
                        }
                        else
                        {
                            strCaption = "Error";
                            strMessage = "Get sensor pressure range error!";
                        }
                        General.g_Common.SetMessageBoxShow(strMessage, strCaption, MessageBoxIcon.Error);
                        bolConnection = false;
                        break;
                    }

                    //measure rate
                    if (frmTest.l_SensorConnectionInfo[i].Characteristics.Length < 12)
                    {
                        frmTest.l_SensorMeasureData[i].MeasureRateMin = 5000;
                        frmTest.l_SensorMeasureData[i].MeasureRateMax = 5000;
                        frmTest.l_SensorMeasureData[i].MeasureRate = 5000;
                    }
                    else
                    {
                        bolStatus = frmTest.GetDeviceMeasureRateData(i, out frmTest.l_SensorMeasureData[i].MeasureRateHex, out strRespondData);
                        General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                        General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);
                        if (bolStatus)
                        {
                            if (frmTest.l_SensorMeasureData[i].MeasureRateHex.Length == 24)
                            {
                                //rate range
                                frmTest.GetDeviceMeasureRateRangeMs(frmTest.l_SensorMeasureData[i].MeasureRateHex, out frmTest.l_SensorMeasureData[i].MeasureRateMin, out frmTest.l_SensorMeasureData[i].MeasureRateMax);

                                //rate
                                frmTest.GetDeviceMeasureRateMs(frmTest.l_SensorMeasureData[i].MeasureRateHex, out frmTest.l_SensorMeasureData[i].MeasureRate);
                            }
                            else
                            {
                                frmTest.l_SensorMeasureData[i].MeasureRateMin = 5000;
                                frmTest.l_SensorMeasureData[i].MeasureRateMax = 5000;
                                frmTest.l_SensorMeasureData[i].MeasureRate = 5000;
                            }
                        }
                        else
                        {
                            if (General.g_Language.ToUpper() == "Chinese".ToUpper())
                            {
                                strCaption = "错误";
                                strMessage = "获取传感器测量速率错误！";
                            }
                            else
                            {
                                strCaption = "Error";
                                strMessage = "Get sensor measure rate error!";
                            }
                            General.g_Common.SetMessageBoxShow(strMessage, strCaption, MessageBoxIcon.Error);
                            bolConnection = false;
                            break;
                        }
                    }

                    //get name
                    //if (frmTest.l_SensorConnectionInfo[i].Characteristics.Length >= 14)
                    //{
                    //    frmTest.GetDeviceDefaultName(i, out frmTest.l_SensorMeasureData[i].DefaultName, out strRespondData);
                    //    General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                    //    General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);

                    //    frmTest.GetDeviceName(i, out frmTest.l_SensorMeasureData[i].Name, out strRespondData);
                    //    General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                    //    General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);

                    //    string strUnitName = "xxxxxx";
                    //    frmTest.SetDeviceName(i, strUnitName, out strRespondData);
                    //    General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                    //    General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);
                    //}

                    //for debug
                    //MessageBox.Show("Address: " + frmTest.l_SensorConnectionInfo[i].Address + ", MeasureRate: " + frmTest.l_SensorMeasureData[i].MeasureRate);
                }
            }

            if (bolConnection)
            {
                General.g_Common.SetControlEnabled(this, true);
                General.g_Common.SetControlCursor(this, Cursors.Default);

                General.g_Common.SetFormDialogResult(this, System.Windows.Forms.DialogResult.OK);
                General.g_Common.SetFormClose(this);
            }
            else
            {
                General.g_Common.SetControlEnabled(this.btnOK, false);
                General.g_Common.SetControlEnabled(this, true);
                General.g_Common.SetControlCursor(this, Cursors.Default);
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            General.g_IsUserTerminate = true;
            General.g_Common.SetFormClose(this);
        }
    }
}
