﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Threading;
using System.IO.Ports;
using System.Windows.Forms.DataVisualization.Charting;

namespace TESS_5600
{
    public partial class frmTest : Form
    {
        #region "COM"
        public static SerialPort mySerialPort = new SerialPort();

        public static string[] GetPortNames()
        {
            List<string> lstStrData = new List<string>();
            foreach (string myComPort in SerialPort.GetPortNames())
            {
                lstStrData.Add(myComPort);
            }
            return lstStrData.ToArray();
        }

        public static string[] GetPortSettings()
        {
            List<string> lstStrData = new List<string>();
            lstStrData.Add("1200,N,8,1");
            lstStrData.Add("2400,N,8,1");
            lstStrData.Add("4800,N,8,1");
            lstStrData.Add("9600,N,8,1");
            lstStrData.Add("19200,N,8,1");
            lstStrData.Add("115200,N,8,1");
            return lstStrData.ToArray();
        }

        public static bool OpenPort(string ThePortName, string ThePortSettings = "9600,N,8,1")
        {
            bool bolValue = false;
            try
            {
                if (mySerialPort.IsOpen)
                {
                    mySerialPort.Close();
                }

                if (ThePortName.ToUpper().Contains("Com".ToUpper()))
                {
                    mySerialPort.PortName = ThePortName;
                }
                else
                {
                    mySerialPort.PortName = "Com".ToUpper() + ThePortName;
                }
                string[] strPortSettings = ThePortSettings.Split(',');

                int intValue = 0;
                int.TryParse(strPortSettings[0], out intValue);
                mySerialPort.BaudRate = intValue;

                if (strPortSettings[1].ToUpper() == "N" ||
                    strPortSettings[1].ToUpper() == "None".ToUpper())
                {
                    mySerialPort.Parity = Parity.None;
                }
                else if (strPortSettings[1].ToUpper() == "Odd".ToUpper())
                {
                    mySerialPort.Parity = Parity.Odd;
                }
                else if (strPortSettings[1].ToUpper() == "Even".ToUpper())
                {
                    mySerialPort.Parity = Parity.Even;
                }
                else
                {
                    mySerialPort.Parity = Parity.None;
                }

                int.TryParse(strPortSettings[2], out intValue);
                mySerialPort.DataBits = intValue;

                if (strPortSettings[3] == "0")
                {
                    mySerialPort.StopBits = StopBits.None;
                }
                else if (strPortSettings[3] == "1")
                {
                    mySerialPort.StopBits = StopBits.One;
                }
                else if (strPortSettings[3] == "2")
                {
                    mySerialPort.StopBits = StopBits.Two;
                }
                else
                {
                    mySerialPort.StopBits = StopBits.One;
                }

                mySerialPort.ReceivedBytesThreshold = 1;
                mySerialPort.DtrEnable = true;
                mySerialPort.RtsEnable = true;

                mySerialPort.Open();
                mySerialPort.DiscardInBuffer();
                mySerialPort.DiscardOutBuffer();

                bolValue = true;
            }
            catch
            { }
            return bolValue;
        }

        public static bool ClosePort()
        {
            bool bolValue = false;
            try
            {
                if (mySerialPort != null && mySerialPort.IsOpen)
                {
                    mySerialPort.Close();
                    //mySerialPort = null;
                }

                bolValue = true;
            }
            catch
            { }
            return bolValue;
        }

        public static void WritePortChar(string TheSting, int TheMilliseconds = 0)
        {
            mySerialPort.DiscardInBuffer();
            mySerialPort.DiscardOutBuffer();
            for (int i = 0; i < TheSting.Length; i++)
            {
                mySerialPort.Write(TheSting.Substring(i, 1));
                General.g_Common.SetDelayMs(TheMilliseconds);
            }
            mySerialPort.Write(Environment.NewLine);
        }

        public static string ReadPortString()
        {
            string strBuffer = "";
            int intCount = 0;

            while (true)
            {
                intCount++;
                string strRespond = "";
                try
                {
                    strRespond = mySerialPort.ReadExisting();
                }
                catch
                { }
                strBuffer += strRespond;
                if (strBuffer.Trim() != "") break;
                if (intCount > 1000) break;
            }
            return strBuffer.Replace(@"""", "");
        }

        public static string ReadPortLine()
        {
            string strBuffer = "";
            try
            {
                strBuffer = mySerialPort.ReadLine();
                strBuffer = strBuffer.Replace(@"""", "");
            }
            catch
            { }
            return strBuffer;
        }

        public void PortDataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            if (!General.g_IsUserTerminate || !General.g_IsChangeDeviceName || !General.g_IsChangeMeasureRate)
            {
                string strBuffer = ReadPortLine();
                string[] strRespondData = strBuffer.Split('\n');
                General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);

                string strConHandle = "", strMatchValue = "", strHandle = "", strValue = "";
                string strRegexString = @"Notification/Indication (.+)";
                if (General.g_Common.GetStringCompare(strBuffer, strRegexString))
                {
                    strMatchValue = General.g_Common.GetStringMatch(strBuffer, strRegexString);

                    strRegexString = "handle = (.+) value:";
                    strHandle = General.g_Common.GetStringMatch(strMatchValue, strRegexString);

                    strRegexString = "value:(.+)";
                    strValue = General.g_Common.GetStringMatch(strMatchValue, strRegexString);

                    strRegexString = " ConHandle:(.+) Notification/Indication handle";
                    strConHandle = General.g_Common.GetStringMatch(strBuffer, strRegexString);

                    for (int i = 0; i < l_SensorConnectionInfo.Length; i++)
                    {
                        if (strConHandle == l_SensorConnectionInfo[i].ConHandle)
                        {
                            //for debug
                            //General.g_Common.SetDebugWindowWriteLine(l_SensorConnectionInfo[i].Address + " + " + l_SensorConnectionInfo[i].ConHandle + " + " + l_SensorMeasureData[i].MeasureRate.ToString());
                            
                            //battery
                            if (strHandle == l_SensorConnectionInfo[i].DutBatteryDataHandle)
                            {
                                l_SensorMeasureData[i].BatteryDataHex = strValue;

                                //battery level
                                GetDeviceBatteryLevel(l_SensorMeasureData[i].BatteryDataHex, out l_SensorMeasureData[i].BatteryLevel);
                                General.g_Common.SetProgressBarValue(SensorBattaryProgressBar[i], l_SensorMeasureData[i].BatteryLevel);
                            }

                            //measure rate
                            if (strHandle == l_SensorConnectionInfo[i].DutMeasureRateHandle)
                            {
                                l_SensorMeasureData[i].MeasureRateHex = strValue;

                                //measure rate
                                GetDeviceMeasureRateMs(l_SensorMeasureData[i].MeasureRateHex, out l_SensorMeasureData[i].MeasureRate);
                            }

                            //measure data
                            if (strHandle == l_SensorConnectionInfo[i].DutMeasureDataHandle)
                            {
                                if (strValue.Length == 28)
                                {
                                    l_SensorMeasureData[i].MeasureDataHex = strValue;

                                    //pressure
                                    GetDevicePressurePsi(l_SensorMeasureData[i].MeasureDataHex, out l_SensorMeasureData[i].MeasurePressurePsi);
                                    if (l_SensorMeasureData[i].MeasurePressureMinPsi > l_SensorMeasureData[i].MeasurePressurePsi)
                                    {
                                        l_SensorMeasureData[i].MeasurePressureMinPsi = l_SensorMeasureData[i].MeasurePressurePsi;
                                    }
                                    if (l_SensorMeasureData[i].MeasurePressureMaxPsi < l_SensorMeasureData[i].MeasurePressurePsi)
                                    {
                                        l_SensorMeasureData[i].MeasurePressureMaxPsi = l_SensorMeasureData[i].MeasurePressurePsi;
                                    }

                                    if (General.g_Common.GetCheckBoxChecked(this.ckbAutoRange))
                                    {
                                        General.g_Common.SetChartChartAreaAxisRange(SensorMeasureChart[i], 0, 1, General.g_Common.GetPressureUnitConvert("psi", l_SensorMeasureData[i].MeasurePressurePsi - 2.0, f_PressureUnit), General.g_Common.GetPressureUnitConvert("psi", l_SensorMeasureData[i].MeasurePressurePsi + 2.0, f_PressureUnit));
                                    }
                                    else
                                    {
                                        General.g_Common.SetChartChartAreaAxisRange(SensorMeasureChart[i], 0, 1, General.g_Common.GetPressureUnitConvert("psi", l_SensorMeasureData[i].MeasurePressureMinPsi, f_PressureUnit), General.g_Common.GetPressureUnitConvert("psi", l_SensorMeasureData[i].MeasurePressureMaxPsi, f_PressureUnit));
                                    }
                                    General.g_Common.SetChartSerieLegendText(SensorMeasureChart[i], 0, "Pressure: " + General.g_Common.GetPressureUnitConvert("psi", l_SensorMeasureData[i].MeasurePressurePsi, f_PressureUnit).ToString() + " " + f_PressureUnit);

                                    if (General.g_Common.GetChartSeriePointsCount(SensorMeasureChart[i], 0) >= 20)
                                    {
                                        General.g_Common.SetChartSeriePointsRemoveAt(SensorMeasureChart[i], 0, 0);
                                    }
                                    General.g_Common.SetChartSeriePointsAddXY(SensorMeasureChart[i], 0, DateTime.Now.ToString("HH:mm:ss"), General.g_Common.GetPressureUnitConvert("psi", l_SensorMeasureData[i].MeasurePressurePsi, f_PressureUnit));

                                    //temperature
                                    GetDeviceTemperqtureC(l_SensorMeasureData[i].MeasureDataHex, out l_SensorMeasureData[i].MeasureTemperatureC);
                                    if (l_SensorMeasureData[i].MeasureTemperatureMinC > l_SensorMeasureData[i].MeasureTemperatureC)
                                    {
                                        l_SensorMeasureData[i].MeasureTemperatureMinC = l_SensorMeasureData[i].MeasureTemperatureC;
                                    }
                                    if (l_SensorMeasureData[i].MeasureTemperatureMaxC < l_SensorMeasureData[i].MeasureTemperatureC)
                                    {
                                        l_SensorMeasureData[i].MeasureTemperatureMaxC = l_SensorMeasureData[i].MeasureTemperatureC;
                                    }

                                    if (General.g_Common.GetCheckBoxChecked(this.ckbAutoRange))
                                    {
                                        General.g_Common.SetChartChartAreaAxisRange(SensorMeasureChart[i], 1, 1, General.g_Common.GetTemperatureUnitConvert("°C", l_SensorMeasureData[i].MeasureTemperatureC - 2.0, f_TemperatureUnit), General.g_Common.GetTemperatureUnitConvert("°C", l_SensorMeasureData[i].MeasureTemperatureC + 2.0, f_TemperatureUnit));
                                    }
                                    else
                                    {
                                        General.g_Common.SetChartChartAreaAxisRange(SensorMeasureChart[i], 1, 1, General.g_Common.GetTemperatureUnitConvert("°C", l_SensorMeasureData[i].MeasureTemperatureMinC, f_TemperatureUnit), General.g_Common.GetTemperatureUnitConvert("°C", l_SensorMeasureData[i].MeasureTemperatureMaxC, f_TemperatureUnit));
                                    }
                                    General.g_Common.SetChartSerieLegendText(SensorMeasureChart[i], 1, "Temperature: " + General.g_Common.GetTemperatureUnitConvert("°C", l_SensorMeasureData[i].MeasureTemperatureC, f_TemperatureUnit).ToString() + " " + f_TemperatureUnit);

                                    if (General.g_Common.GetChartSeriePointsCount(SensorMeasureChart[i], 1) >= 20)
                                    {
                                        General.g_Common.SetChartSeriePointsRemoveAt(SensorMeasureChart[i], 1, 0);
                                    }
                                    General.g_Common.SetChartSeriePointsAddXY(SensorMeasureChart[i], 1, DateTime.Now.ToString("HH:mm:ss"), General.g_Common.GetTemperatureUnitConvert("°C", l_SensorMeasureData[i].MeasureTemperatureC, f_TemperatureUnit));
                                }
                            }

                            //save data
                            if (General.g_Common.GetCheckBoxChecked(this.ckbDataLog))
                            {
                                string strLine = "";
                                if (!General.g_Common.GetFileExists(l_SensorConnectionInfo[i].DataLogFile))
                                {
                                    strLine = "Pressure Range Min(psi): " + l_SensorMeasureData[i].MeasurePressureRangeMinPsi;
                                    General.g_Common.SetTextFileWriteLine(l_SensorConnectionInfo[i].DataLogFile, strLine);
                                    strLine = "Pressure Range Max(psi): " + l_SensorMeasureData[i].MeasurePressureRangeMaxPsi;
                                    General.g_Common.SetTextFileWriteLine(l_SensorConnectionInfo[i].DataLogFile, strLine);

                                    string strHeader = "Date Time" + "\t" + "MAC Address" + "\t" + "Product Name" + "\t" + "Battery Level(%)" + "\t";
                                    strHeader += "Temperature Value(°C)" + "\t" + "Pressure Value(psi)";
                                    General.g_Common.SetTextFileWriteLine(l_SensorConnectionInfo[i].DataLogFile, strHeader);
                                }

                                strLine = DateTime.Now.ToString() + "\t" + l_SensorConnectionInfo[i].Address + "\t" + l_SensorConnectionInfo[i].Name + "\t";
                                strLine += l_SensorMeasureData[i].BatteryLevel.ToString() + "\t" + l_SensorMeasureData[i].MeasureTemperatureC.ToString() + "\t" + l_SensorMeasureData[i].MeasurePressurePsi.ToString();
                                General.g_Common.SetTextFileWriteLine(l_SensorConnectionInfo[i].DataLogFile, strLine);
                            }

                            if (General.g_IsUserTerminate)
                            {
                                for (int n = 0; n < 5; n++)
                                {
                                    mySerialPort.DataReceived -= new SerialDataReceivedEventHandler(PortDataReceived);
                                }
                                mySerialPort.DiscardInBuffer();
                                mySerialPort.DiscardOutBuffer();

                                for (int k = 0; k < l_SensorConnectionInfo.Length; k++)
                                {
                                    DisabledDeviceBatteryNotified(k, out strRespondData);
                                    General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);

                                    DisabledDeviceMeasureDataNotified(k, out strRespondData);
                                    General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);

                                    DisabledDeviceMeasureRateNotified(k, out strRespondData);
                                    General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);

                                    mySerialPort.DiscardInBuffer();
                                    mySerialPort.DiscardOutBuffer();
                                }

                                mySerialPort.DataReceived -= new SerialDataReceivedEventHandler(PortDataReceived);
                                mySerialPort.DiscardInBuffer();
                                mySerialPort.DiscardOutBuffer();

                                General.g_Common.SetControlCursor(this, Cursors.Default);
                                General.g_Common.SetControlEnabled(this.btnScan, true);
                                break;
                            }
                        }
                    }
                }
            }
        }
        #endregion

        #region "SmartZ"
        public static bool StartSmartZ(out string[] RespondData)
        {
            bool bolStatus = false;
            string strCommand = "";
            string strBuffer = "";
            string strRespond = "";

            int intCount = 0;
            while (true)
            {
                intCount++;

                strCommand = "at";
                WritePortChar(strCommand);
                General.g_Common.SetDelayMs(100);
                strBuffer = ReadPortString();

                string strRegexString = @"(.+)\n00\r";
                if (General.g_Common.GetStringCompare(strBuffer, strRegexString))
                {
                    bolStatus = true;
                    break;
                }
                else
                {
                    strCommand = "quit";
                    WritePortChar(strCommand);
                }

                if (intCount > 20)
                {
                    break;
                }
            }

            if (bolStatus)
            {
                strCommand = "smartZ";
                WritePortChar(strCommand);
                while (true)
                {
                    strBuffer = ReadPortString();
                    strRespond += strBuffer;

                    string strRegexString = @"\n-----------------------\n(.+)\n-----------------------\n\nType help or <command> help\n------->";
                    if (General.g_Common.GetStringCompare(strRespond, strRegexString))
                    {
                        break;
                    }
                }
            }

            RespondData = strRespond.Split('\n');
            return bolStatus;
        }

        public static bool StopSmartZ()
        {
            bool bolValue = false;
            try
            {
                string strCommand = "quit";
                WritePortChar(strCommand);

                bolValue = true;
            }
            catch
            { }
            return bolValue;
        }

        public static bool ScanningSensor(int ScanSeconds, out string[] SensorsData, out string[] RespondData)
        {
            bool bolStatus = false;
            string strCommand = "";
            string strBuffer = "";
            string strRespond = "";
            string strMatchValue = "";

            strCommand = "hcitool lescan --length=" + ScanSeconds.ToString();
            WritePortChar(strCommand);

            int intCount = 0;
            while (true)
            {
                intCount++;
                General.g_Common.SetDelayMs(10);

                strBuffer = ReadPortString();
                strRespond += strBuffer;

                string strRegexString = @"LE Scan ...\n------->\n(.+)\n------->";
                if (General.g_Common.GetStringCompare(strRespond, strRegexString))
                {
                    strMatchValue = General.g_Common.GetStringMatch(strRespond, strRegexString);
                    bolStatus = true;
                    break;
                }

                if (strRespond == "LE Scan ...\n------->\n------->")
                {
                    strCommand = "hcitool lescan --length=" + ScanSeconds.ToString();
                    WritePortChar(strCommand);
                    strRespond = "";
                }

                if (intCount > ScanSeconds * 1.5 * 1000 / 10) break;
                if (General.g_IsUserTerminate) break;
            }

            List<string> lstStrData = new List<String>();
            string[] strData = strMatchValue.Split('\n');
            for (int i = 0; i < strData.Length; i++)
            {
                string strRegexString = @"MAC:" + BL900Type + "(.+)NAME";
                if (General.g_Common.GetStringCompare(strData[i], strRegexString))
                {
                    string strAddress = General.g_Common.GetStringMatch(strData[i], strRegexString);

                    strRegexString = @"NAME:(.+)RSSI";
                    string strName = General.g_Common.GetStringMatch(strData[i], strRegexString);
                    strName = strName.Replace("\0", "");

                    strRegexString = @"RSSI:(.+)";
                    string strRssi = General.g_Common.GetStringMatch(strData[i], strRegexString);

                    string strDevice = "MAC: " + strAddress + " NAME: " + strName + " RSSI: " + strRssi;

                    bool bolValue = false;
                    foreach (string strItem in lstStrData)
                    {
                        if (strItem.IndexOf(strAddress) != -1)
                        {
                            bolValue = true;
                            break;
                        }
                        else
                        {
                            bolValue = false;
                        }
                    }

                    if (!bolValue)
                    {
                        lstStrData.Add(strDevice);
                    }
                }
            }

            lstStrData.Sort();
            SensorsData = lstStrData.ToArray();
            RespondData = null;
            RespondData = strRespond.Split('\n');
            return bolStatus;
        }

        public static bool ConnectingSensor(string Address, out string ConHandle, out string[] RespondData)
        {
            bool bolStatus = false;
            string strCommand = "";
            string strBuffer = "";
            string strRespond = "";

            strCommand = "hcitool lecc " + BL900Type + Address;
            WritePortChar(strCommand);

            string strMatchValue = "";
            int intCount = 0;
            while (true)
            {
                General.g_Common.SetDelayMs(10);
                intCount++;

                strBuffer = ReadPortString();
                strRespond += strBuffer;

                string strRegexString = @"Connecting ... \n------->\nConnection handle (.+)\n------->";
                if (General.g_Common.GetStringCompare(strRespond, strRegexString))
                {
                    strMatchValue = General.g_Common.GetStringMatch(strRespond, strRegexString);
                    bolStatus = true;
                    break;
                }

                if (strRespond == "Connecting ... \n------->\nCould not create connection: Connection timed out\n------->")
                {
                    strCommand = "hcitool lecc " + BL900Type + Address;
                    WritePortChar(strCommand);
                    strRespond = "";
                }

                strRegexString = @"error: (.+)\n------->";
                if (General.g_Common.GetStringCompare(strRespond, strRegexString))
                {
                    break;
                }

                if (intCount > 1000) break;
                if (General.g_IsUserTerminate) break;
            }

            ConHandle = strMatchValue;
            RespondData = null;
            RespondData = strRespond.Split('\n');
            return bolStatus;
        }

        public static bool DisconnectingSensor(string ConHandle, out string[] RespondData)
        {
            bool bolStatus = false;
            string strCommand = "";
            string strBuffer = "";
            string strRespond = "";

            strCommand = "hcitool ledc " + ConHandle;
            WritePortChar(strCommand);

            int intCount = 0;
            while (true)
            {
                General.g_Common.SetDelayMs(10);
                intCount++;

                strBuffer = ReadPortString();
                strRespond += strBuffer;

                if (strRespond == "Disconnecting ...\n------->\nDisconnected\n------->")
                {
                    bolStatus = true;
                    break;
                }

                if (intCount > 1000) break;
                if (General.g_IsUserTerminate) break;
            }

            RespondData = null;
            RespondData = strRespond.Split('\n');
            return bolStatus;
        }

        public static void DisplayingActiveConnections(out string[] ActiveAddress, out string[] ActiveHandle, out string[] RespondData)
        {
            string strCommand = "";
            string strBuffer = "";
            string strRespond = "";

            strCommand = "hcitool con";
            WritePortChar(strCommand);

            string[] strMatchData = { };
            string[] strAddressData = { };
            string[] strHandleData = { };
            while (true)
            {
                strBuffer = ReadPortString();
                strRespond += strBuffer;

                string strRegexString = @"Connections:\n\t> (.+)\n------->";
                if (General.g_Common.GetStringCompare(strRespond, strRegexString))
                {
                    strMatchData = General.g_Common.GetStringMatch(strRespond, strRegexString).Split('\n');
                    strAddressData = new string[strMatchData.Length];
                    strHandleData = new string[strMatchData.Length];

                    for (int i = 0; i < strMatchData.Length; i++)
                    {
                        strRegexString = BL900Type.ToString() + @"(.+)handle";
                        if (General.g_Common.GetStringCompare(strMatchData[i], strRegexString))
                        {
                            strAddressData[i] = General.g_Common.GetStringMatch(strMatchData[i], strRegexString);
                        }

                        strRegexString = @"handle(.+)";
                        if (General.g_Common.GetStringCompare(strMatchData[i], strRegexString))
                        {
                            strHandleData[i] = General.g_Common.GetStringMatch(strMatchData[i], strRegexString);
                        }
                    }
                    break;
                }

                strRegexString = @"(.+)Could not create connection: Connection timed out(.+)";
                if (General.g_Common.GetStringCompare(strRespond, strRegexString))
                {
                    break;
                }
            }

            ActiveAddress = strAddressData;
            ActiveHandle = strHandleData;
            RespondData = null;
            RespondData = strRespond.Split('\n');
        }

        public static void DiscoveringPrimaryServices(string Address, out string[] PrimaryServices, out string[] RespondData)
        {
            string strCommand = "";
            string strBuffer = "";
            string strRespond = "";

            strCommand = "gatttool –b " + BL900Type + Address + " --primary";
            WritePortChar(strCommand);

            string strMatchValue = "";
            while (true)
            {
                strBuffer = ReadPortString();
                strRespond += strBuffer;

                string strRegexString = @"------->\n(.+)\n------->";
                if (General.g_Common.GetStringCompare(strRespond, strRegexString))
                {
                    strMatchValue = General.g_Common.GetStringMatch(strRespond, strRegexString);
                    break;
                }
            }

            PrimaryServices = strMatchValue.Split('\n');
            RespondData = null;
            RespondData = strRespond.Split('\n');
        }

        public static void DiscoveringCharacteristics(string Address, out string[] Characteristics, out string[] RespondData)
        {
            string strCommand = "";
            string strBuffer = "";
            string strRespond = "";

            strCommand = "gatttool –b " + BL900Type + Address + " --characteristics";
            WritePortChar(strCommand);

            string strMatchValue = "";
            while (true)
            {
                strBuffer = ReadPortString();
                strRespond += strBuffer;

                string strRegexString = @"------->\n(.+)\n------->";
                if (General.g_Common.GetStringCompare(strRespond, strRegexString))
                {
                    strMatchValue = General.g_Common.GetStringMatch(strRespond, strRegexString);
                    break;
                }
            }

            Characteristics = strMatchValue.Split('\n');
            RespondData = null;
            RespondData = strRespond.Split('\n');
        }

        public static void GetCharacteristicsHandle(string[] Characteristics, string CharacteristicsUUID, out string CharacteristicsHandle)
        {
            CharacteristicsHandle = "";
            for (int i = 0; i < Characteristics.Length; i++)
            {
                string strRegexString = @"UUID:(.+)";
                string strMatchValue = General.g_Common.GetStringMatch(Characteristics[i], strRegexString);
                if (strMatchValue == CharacteristicsUUID)
                {
                    strRegexString = @"char value handle:(.+), UUID";
                    strMatchValue = General.g_Common.GetStringMatch(Characteristics[i], strRegexString);
                    CharacteristicsHandle = strMatchValue;
                    break;
                }
            }
        }

        public static bool ReadingCharacteristicsOrDescriptorsValues(string Address, string CharacteristicsHandle, out string Value, out string[] RespondData)
        {
            bool bolStatus = false;
            string strCommand = "";
            string strBuffer = "";
            string strRespond = "";

            strCommand = "gatttool –b " + BL900Type + Address + " --char-read --handle=" + CharacteristicsHandle;
            WritePortChar(strCommand);

            string strMatchValue = "";
            int intCount = 0;
            while (true)
            {
                General.g_Common.SetDelayMs(10);
                intCount++;

                strBuffer = ReadPortString();
                strRespond += strBuffer;

                string strRegexString = @"value/descriptor: (.+)\n------->";
                if (General.g_Common.GetStringCompare(strRespond, strRegexString))
                {
                    strMatchValue = General.g_Common.GetStringMatch(strRespond, strRegexString);
                    int intEnd = strMatchValue.IndexOf("(");
                    strMatchValue = strMatchValue.Substring(0, intEnd - 1);
                    bolStatus = true;
                    break;
                }

                if (intCount > 1000) break;
                if (General.g_IsUserTerminate) break;
            }

            Value = strMatchValue;
            RespondData = null;
            RespondData = strRespond.Split('\n');
            return bolStatus;
        }

        public static bool WritingCharacteristicOrDescriptorValues(string Address, string CharacteristicsHandle, string Value, out string[] RespondData)
        {
            bool bolStatus = false;
            string strCommand = "";
            string strBuffer = "";
            string strRespond = "";

            strCommand = "gatttool –b " + BL900Type + Address + " --char-write --handle=" + CharacteristicsHandle + " --value=" + Value;
            WritePortChar(strCommand);

            int intCount = 0;
            while (true)
            {
                General.g_Common.SetDelayMs(10);
                intCount++;

                strBuffer = ReadPortString();
                strRespond += strBuffer;

                if (strRespond == "------->\nCharacteristic value was written successfully\n------->")
                {
                    bolStatus = true;
                    break;
                }

                if (intCount > 1000) break;
                if (General.g_IsUserTerminate) break;
            }

            RespondData = null;
            RespondData = strRespond.Split('\n');
            return bolStatus;
        }

        public static bool EnablingNotificationsOrIndications(string Address, string CharacteristicsNotifiedHandle, out string[] RespondData)
        {
            bool bolStatus = false;
            string strCommand = "";
            string strBuffer = "";
            string strRespond = "";

            strCommand = "gatttool -b " + BL900Type + Address + " --char-write --handle=" + CharacteristicsNotifiedHandle + " --value=0100 --listen";
            WritePortChar(strCommand);

            int intCount = 0;
            while (true)
            {
                intCount++;
                General.g_Common.SetDelayMs(10);

                strBuffer = ReadPortString();
                strRespond += strBuffer;

                string strRegexString = "Characteristic value was written successfully";
                if (strRespond.Contains(strRegexString))
                {
                    bolStatus = true;
                    break;
                }

                if (intCount > 1000) break;
                if (General.g_IsUserTerminate) break;
            }

            RespondData = null;
            RespondData = strRespond.Split('\n');
            return bolStatus;
        }

        public static bool DisablingNotificationsOrIndications(string Address, string CharacteristicsNotifiedHandle, out string[] RespondData)
        {
            bool bolStatus = false;
            string strCommand = "";
            string strBuffer = "";
            string strRespond = "";

            strCommand = "gatttool -b " + BL900Type + Address + " --char-write --handle=" + CharacteristicsNotifiedHandle + " --value=0200 --listen";
            WritePortChar(strCommand);

            int intCount = 0;
            while (true)
            {
                intCount++;
                General.g_Common.SetDelayMs(10);

                strBuffer = ReadPortString();
                strRespond += strBuffer;

                string strRegexString = "Characteristic value was written successfully";
                if (strRespond.Contains(strRegexString))
                {
                    bolStatus = true;
                    break;
                }

                if (intCount > 1000)
                {
                    break;
                }
                //if (General.g_IsUserTerminate) break;
            }

            RespondData = null;
            RespondData = strRespond.Split('\n');
            return bolStatus;
        }

        public static void DisplayVersionInformation(out string[] RespondData)
        {
            string strCommand = "";
            string strBuffer = "";
            string strRespond = "";

            strCommand = "hciconfig version";
            WritePortChar(strCommand);

            string strMatchValue = "";
            while (true)
            {
                strBuffer = ReadPortString();
                strRespond += strBuffer;

                string strRegexString = @"\nApp (.+)\n------->";
                if (General.g_Common.GetStringCompare(strRespond, strRegexString))
                {
                    strMatchValue = General.g_Common.GetStringMatch(strRespond, strRegexString);
                    break;
                }
            }

            RespondData = null;
            RespondData = strRespond.Split('\n');
        }
        #endregion

        #region "M5600"
        const string BL900Type = "01";

        public static string DutBatteryDataUUID;
        public static string DutMeasureDataUUID;
        public static string DutMeasureRateUUID;
        public static string DutMeasureStatusUUID;

        public static string DutDefaultNameUUID;
        public static string DutNameUUID;

        public struct SensorConnectionInfo
        {
            public string Address;
            public string Name;
            public string Rssi;
            public string ConHandle;

            public string[] Characteristics;
            public string DutBatteryDataHandle;
            public string DutBatteryDataNotifiedHandle;
            public string DutMeasureDataHandle;
            public string DutMeasureDataNotifiedHandle;
            public string DutMeasureRateHandle;
            public string DutMeasureRateNotifiedHandle;
            public string DutMeasureStatusHandle;

            public string DutDefaultNameHandle;
            public string DutNameHandle;

            public bool IsConnect;
            public string DataLogFile;
        }
        public static SensorConnectionInfo[] l_SensorConnectionInfo;

        public struct SensorMeasureData
        {
            public string BatteryDataHex;
            public int BatteryLevel;
            public string BatteryStatus;

            public string MeasureDataHex;

            public double MeasurePressurePsi;
            public double MeasurePressureMinPsi;
            public double MeasurePressureMaxPsi;

            public double MeasurePressureRangeMinPsi;
            public double MeasurePressureRangeMaxPsi;

            public double MeasureTemperatureC;
            public double MeasureTemperatureMinC;
            public double MeasureTemperatureMaxC;

            public string MeasureRateHex;
            public uint MeasureRate;
            public uint MeasureRateMin;
            public uint MeasureRateMax;

            public string DefaultName;
            public string Name;
        }
        public static SensorMeasureData[] l_SensorMeasureData;

        public static bool OpenDongle(out string[] RespondData)
        {
            bool bolValue = StartSmartZ(out RespondData);
            if (!bolValue)
            {
                string strCaption = string.Empty;
                string strMessage = string.Empty;
                if (General.g_Language.ToUpper() == "Chinese".ToUpper())
                {
                    strCaption = "错 误";
                    strMessage = "启动：StartZ 错误！";
                }
                else
                {
                    strCaption = "Error";
                    strMessage = "Start Smartz error!";
                }
                General.g_Common.SetMessageBoxShow(strMessage, strCaption, MessageBoxIcon.Error);
            }
            return bolValue;
        }

        public static void CloseDongle()
        {
            StopSmartZ();
            ClosePort();
        }

        public static void ScanSensor(int ScanSeconds, out string[] SensorsData, out string[] RespondData)
        {
            ScanningSensor(ScanSeconds, out SensorsData, out RespondData);
        }

        public static bool ConnectDevice(string Address, out string ConHandle, out string[] RespondData)
        {
            bool bolStatus = false;
            int intCount = 0;
            while (true)
            {
                intCount++;

                if (ConnectingSensor(Address, out ConHandle, out RespondData))
                {
                    bolStatus = true;
                    break;
                }

                if (intCount > 5) break;
            }
            return bolStatus;
        }

        public static void DisconnectDevice(string ConHandle, out string[] RespondData)
        {
            DisconnectingSensor(ConHandle, out RespondData);
        }

        public static void GetDeviceCharacteristics(string Address, out string[] Characteristics, out string[] RespondData)
        {
            DiscoveringCharacteristics(Address, out Characteristics, out RespondData);
        }

        public static bool GetDeviceMeasureData(int index, out string MeasureDataHex, out string[] RespondData)
        {
            DutMeasureDataUUID = "F000AB31-0451-4000-B000-000000000000".Replace("-", "");
            //DutMeasureDataHandle = "0x0000001B";
            //DutMeasureDataNotifiedHandle = "0x0000001D";
            GetCharacteristicsHandle(l_SensorConnectionInfo[index].Characteristics, DutMeasureDataUUID, out l_SensorConnectionInfo[index].DutMeasureDataHandle);
            l_SensorConnectionInfo[index].DutMeasureDataNotifiedHandle = "0x" + General.g_Common.GetDecToHex(General.g_Common.GetHexToDec(l_SensorConnectionInfo[index].DutMeasureDataHandle) + 2);

            string strValue = "";
            bool bolStatus = ReadingCharacteristicsOrDescriptorsValues(l_SensorConnectionInfo[index].Address, l_SensorConnectionInfo[index].DutMeasureDataHandle, out strValue, out RespondData);
            MeasureDataHex = strValue;
            return bolStatus;
        }

        public static void EnabledDeviceMeasureDataNotified(int index, out string[] RespondData)
        {
            DutMeasureDataUUID = "F000AB31-0451-4000-B000-000000000000".Replace("-", "");
            //DutMeasureDataHandle = "0x0000001B";
            //DutMeasureDataNotifiedHandle = "0x0000001D";
            //GetCharacteristicsHandle(myCurrentInfo.DeviceCharacteristics, myCurrentInfo.DeviceMeasureRateUUID, out myCurrentInfo.DeviceMeasureRateHandle);

            EnablingNotificationsOrIndications(l_SensorConnectionInfo[index].Address, l_SensorConnectionInfo[index].DutMeasureDataNotifiedHandle, out RespondData);
        }

        public static void DisabledDeviceMeasureDataNotified(int index, out string[] RespondData)
        {
            DutMeasureDataUUID = "F000AB31-0451-4000-B000-000000000000".Replace("-", "");
            //DutMeasureDataHandle = "0x0000001B";
            //DutMeasureDataNotifiedHandle = "0x0000001D";
            //mySmartZ.GetCharacteristicsHandle(myCurrentInfo.DeviceCharacteristics, myCurrentInfo.DeviceMeasureRateUUID, out myCurrentInfo.DeviceMeasureRateHandle);

            DisablingNotificationsOrIndications(l_SensorConnectionInfo[index].Address, l_SensorConnectionInfo[index].DutMeasureDataNotifiedHandle, out RespondData);
        }

        public static bool GetDeviceMeasureRateData(int index, out string MeasureRateDataHex, out string[] RespondData)
        {
            DutMeasureRateUUID = "F000AB32-0451-4000-B000-000000000000".Replace("-", "");
            //DutMeasureRateHandle = "0x0000001F";
            //DutMeasureRateNotifiedHandle = "0x00000021";
            GetCharacteristicsHandle(l_SensorConnectionInfo[index].Characteristics, DutMeasureRateUUID, out l_SensorConnectionInfo[index].DutMeasureRateHandle);
            l_SensorConnectionInfo[index].DutMeasureRateNotifiedHandle = "0x" + General.g_Common.GetDecToHex(General.g_Common.GetHexToDec(l_SensorConnectionInfo[index].DutMeasureRateHandle) + 2);

            string strValue = "";
            bool bolStatus = ReadingCharacteristicsOrDescriptorsValues(l_SensorConnectionInfo[index].Address, l_SensorConnectionInfo[index].DutMeasureRateHandle, out strValue, out RespondData);
            MeasureRateDataHex = strValue;
            return bolStatus;
        }

        public static void EnabledDeviceMeasureRateNotified(int index, out string[] RespondData)
        {
            DutMeasureRateUUID = "F000AB32-0451-4000-B000-000000000000".Replace("-", "");
            //DutMeasureRateHandle = "0x0000001F";
            //DutMeasureRateNotifiedHandle = "0x00000021";
            //mySmartZ.GetCharacteristicsHandle(myCurrentInfo.DeviceCharacteristics, myCurrentInfo.DeviceMeasureRateUUID, out myCurrentInfo.DeviceMeasureRateHandle);

            EnablingNotificationsOrIndications(l_SensorConnectionInfo[index].Address, l_SensorConnectionInfo[index].DutMeasureRateNotifiedHandle, out RespondData);
        }

        public static void DisabledDeviceMeasureRateNotified(int index, out string[] RespondData)
        {
            DutMeasureRateUUID = "F000AB32-0451-4000-B000-000000000000".Replace("-", "");
            //DutMeasureRateHandle = "0x0000001F";
            //DutMeasureRateNotifiedHandle = "0x00000021";
            //mySmartZ.GetCharacteristicsHandle(myCurrentInfo.DeviceCharacteristics, myCurrentInfo.DeviceMeasureRateUUID, out myCurrentInfo.DeviceMeasureRateHandle);

            DisablingNotificationsOrIndications(l_SensorConnectionInfo[index].Address, l_SensorConnectionInfo[index].DutMeasureRateNotifiedHandle, out RespondData);
        }

        public static void SetDeviceMeasureRate(int index, string MeasureRateHex, out string[] RespondData)
        {
            DutMeasureRateUUID = "F000AB32-0451-4000-B000-000000000000".Replace("-", "");
            //DutMeasureRateHandle = "0x0000001F";
            //DutMeasureRateNotifiedHandle = "0x00000020";
            //mySmartZ.GetCharacteristicsHandle(myCurrentInfo.DeviceCharacteristics, myCurrentInfo.DeviceMeasureRateUUID, out myCurrentInfo.DeviceMeasureRateHandle);

            string strValue = MeasureRateHex;
            WritingCharacteristicOrDescriptorValues(l_SensorConnectionInfo[index].Address, l_SensorConnectionInfo[index].DutMeasureRateHandle, strValue, out RespondData);
            MeasureRateHex = strValue;
        }

        public static void GetDeviceMeasureStatus(int index, out string MeasureStatusHex, out string[] RespondData)
        {
            //STATUS
            //0x00 OK
            //0x01 Sensor error
            DutMeasureStatusUUID = "F000AB3F-0451-4000-B000-000000000000".Replace("-", "");
            //DutMeasureStatusHandle = "0x00000023";
            GetCharacteristicsHandle(l_SensorConnectionInfo[index].Characteristics, DutMeasureStatusUUID, out l_SensorConnectionInfo[index].DutMeasureStatusHandle);

            string strValue = "";
            ReadingCharacteristicsOrDescriptorsValues(l_SensorConnectionInfo[index].Address, l_SensorConnectionInfo[index].DutMeasureStatusHandle, out strValue, out RespondData);
            MeasureStatusHex = strValue;
        }

        //for new firmware
        public static void GetDeviceDefaultName(int index, out string DeviceDefaultName, out string[] RespondData)
        {
            DutDefaultNameUUID = "F000FA02-0451-4000-B000-000000000000".Replace("-", "");
            GetCharacteristicsHandle(l_SensorConnectionInfo[index].Characteristics, DutDefaultNameUUID, out l_SensorConnectionInfo[index].DutDefaultNameHandle);

            string strValue = "";
            ReadingCharacteristicsOrDescriptorsValues(l_SensorConnectionInfo[index].Address, l_SensorConnectionInfo[index].DutDefaultNameHandle, out strValue, out RespondData);

            DeviceDefaultName = "";
            for (int i = 0; i < strValue.Length; i += 2)
            { 
                string strHex=strValue.Substring(i, 2);
                int intValue=0;
                intValue = General.g_Common.GetHexToDec(strHex);
                string strChar = General.g_Common.GetAscToChr(intValue);
                DeviceDefaultName += strChar;
            }
        }

        public static void GetDeviceName(int index, out string DeviceName, out string[] RespondData)
        {
            DutNameUUID = "F000FA01-0451-4000-B000-000000000000".Replace("-", "");
            GetCharacteristicsHandle(l_SensorConnectionInfo[index].Characteristics, DutNameUUID, out l_SensorConnectionInfo[index].DutNameHandle);

            string strValue = "";
            ReadingCharacteristicsOrDescriptorsValues(l_SensorConnectionInfo[index].Address, l_SensorConnectionInfo[index].DutNameHandle, out strValue, out RespondData);

            DeviceName = "";
            for (int i = 0; i < strValue.Length; i += 2)
            {
                string strHex = strValue.Substring(i, 2);
                int intValue = 0;
                intValue = General.g_Common.GetHexToDec(strHex);
                string strChar = General.g_Common.GetAscToChr(intValue);
                DeviceName += strChar;
            }
        }

        public static void SetDeviceName(int index, string DeviceName, out string[] RespondData)
        {
            DutNameUUID = "F000FA01-0451-4000-B000-000000000000".Replace("-", "");
            GetCharacteristicsHandle(l_SensorConnectionInfo[index].Characteristics, DutNameUUID, out l_SensorConnectionInfo[index].DutNameHandle);

            string strValue = "";
            for (int i = 0; i < DeviceName.Length; i++)
            {
                string strASCII = DeviceName.Substring(i, 1);
                int intValue = 0;
                intValue = General.g_Common.GetChrToAsc(strASCII);
                strValue += intValue.ToString("X2");
            }
            WritingCharacteristicOrDescriptorValues(l_SensorConnectionInfo[index].Address, l_SensorConnectionInfo[index].DutNameHandle, strValue, out RespondData);
            DeviceName = strValue;
        }

        public static void GetDeviceTemperqtureC(string MeasureDataHex, out double Temperature, int DecimalPlace = 3)
        {
            string strValue = MeasureDataHex.Substring(0, 4);
            byte[] bytData = new byte[strValue.Length / 2];
            for (int i = 0; i < strValue.Length; i += 2)
            {
                bytData[i / 2] = General.g_Common.GetHexToByte(strValue.Substring(i, 2));
            }
            int intValue = General.g_Common.GetByteToInt16(bytData);

            int intError = General.g_Common.GetHexToDec("7FFF");
            if (intValue > intError)
            {
                intValue = intValue - General.g_Common.GetHexToDec("FFFF");
            }
            double dblValue = (double)intValue / 100;
            Temperature = Math.Round(dblValue, DecimalPlace);
        }

        public static void GetDevicePressurePsi(string MeasureDataHex, out double Pressure, int DecimalPlace = 3)
        {
            string strValue = MeasureDataHex.Substring(4, 8);
            byte[] bytData = new byte[strValue.Length / 2];
            for (int i = 0; i < strValue.Length; i += 2)
            {
                bytData[i / 2] = General.g_Common.GetHexToByte(strValue.Substring(i, 2));
            }
            int intValue = General.g_Common.GetByteToInt32(bytData);

            int intError = General.g_Common.GetHexToDec("7FFFFFFF");
            if (intValue > intError)
            {
                intValue = intValue - General.g_Common.GetHexToDec("FFFFFFFF");
            }

            double dblValue = (double)intValue / 10;
            dblValue = dblValue / 6894.7;
            Pressure = Math.Round(dblValue, DecimalPlace);
        }

        public static void GetDevicePressureRangePsi(string MeasureDataHex, out double PressureMin, out double PressureMax, int DecimalPlace = 3)
        {
            string strValue = MeasureDataHex.Substring(12, 8);
            byte[] bytData = new byte[strValue.Length / 2];
            for (int i = 0; i < strValue.Length; i += 2)
            {
                bytData[i / 2] = General.g_Common.GetHexToByte(strValue.Substring(i, 2));
            }
            int intValue = General.g_Common.GetByteToInt32(bytData);

            int intError = General.g_Common.GetHexToDec("7FFFFFFF");
            if (intValue > intError)
            {
                intValue = intValue - General.g_Common.GetHexToDec("FFFFFFFF");
            }

            double dblValue = (double)intValue / 10;
            dblValue = dblValue / 6894.7;
            PressureMin = Math.Round(dblValue, DecimalPlace);

            strValue = MeasureDataHex.Substring(20, 8);
            bytData = new byte[strValue.Length / 2];
            for (int i = 0; i < strValue.Length; i += 2)
            {
                bytData[i / 2] = General.g_Common.GetHexToByte(strValue.Substring(i, 2));
            }
            intValue = General.g_Common.GetByteToInt32(bytData);

            intError = General.g_Common.GetHexToDec("7FFFFFFF");
            if (intValue > intError)
            {
                intValue = intValue - General.g_Common.GetHexToDec("FFFFFFFF");
            }

            dblValue = (double)intValue / 10;
            dblValue = dblValue / 6894.7;
            PressureMax = Math.Round(dblValue, DecimalPlace);
        }

        public static void GetDeviceMeasureRateMs(string DataRateDataHex, out uint DataRate)
        {
            string strValue = DataRateDataHex.Substring(0, 8);
            byte[] bytData = new byte[strValue.Length / 2];
            for (int i = 0; i < strValue.Length; i += 2)
            {
                bytData[i / 2] = General.g_Common.GetHexToByte(strValue.Substring(i, 2));
            }
            DataRate = General.g_Common.GetByteToUInt32(bytData);
        }

        public static void GetDeviceMeasureRateRangeMs(string TheDataRateDataHex, out uint TheDataRateMin, out uint TheDataRateMax)
        {
            string strValue = TheDataRateDataHex.Substring(8, 8);
            byte[] bytData = new byte[strValue.Length / 2];
            for (int i = 0; i < strValue.Length; i += 2)
            {
                bytData[i / 2] = General.g_Common.GetHexToByte(strValue.Substring(i, 2));
            }
            TheDataRateMin = General.g_Common.GetByteToUInt32(bytData);

            strValue = TheDataRateDataHex.Substring(16, 8);
            bytData = new byte[strValue.Length / 2];
            for (int i = 0; i < strValue.Length; i += 2)
            {
                bytData[i / 2] = General.g_Common.GetHexToByte(strValue.Substring(i, 2));
            }
            TheDataRateMax = General.g_Common.GetByteToUInt32(bytData);
        }

        public static bool GetDeviceBatteryData(int index, out string TheBatteryData, out string[] RespondData)
        {
            DutBatteryDataUUID = "F0002A19-0451-4000-B000-000000000000".Replace("-", "");
            //DutBatteryDataHandle = "0x00000016";
            //DutBatteryDataNotifiedHandle = "0x00000018";
            GetCharacteristicsHandle(l_SensorConnectionInfo[index].Characteristics, DutBatteryDataUUID, out l_SensorConnectionInfo[index].DutBatteryDataHandle);
            l_SensorConnectionInfo[index].DutBatteryDataNotifiedHandle = "0x" + General.g_Common.GetDecToHex(General.g_Common.GetHexToDec(l_SensorConnectionInfo[index].DutBatteryDataHandle) + 2);

            string strValue = "";
            bool bolStatus = ReadingCharacteristicsOrDescriptorsValues(l_SensorConnectionInfo[index].Address, l_SensorConnectionInfo[index].DutBatteryDataHandle, out strValue, out RespondData);
            TheBatteryData = strValue;
            return bolStatus;
        }

        public static void EnabledDeviceBatteryNotified(int index, out string[] RespondData)
        {
            DutBatteryDataUUID = "F0002A19-0451-4000-B000-000000000000".Replace("-", "");
            //DutBatteryDataHandle = "0x00000016";
            //DutBatteryDataNotifiedHandle = "0x00000018";
            //GetCharacteristicsHandle(myCurrentInfo.DeviceCharacteristics, myCurrentInfo.DeviceMeasureRateUUID, out myCurrentInfo.DeviceMeasureRateHandle);

            EnablingNotificationsOrIndications(l_SensorConnectionInfo[index].Address, l_SensorConnectionInfo[index].DutBatteryDataNotifiedHandle, out RespondData);
        }

        public static void DisabledDeviceBatteryNotified(int index, out string[] RespondData)
        {
            DutBatteryDataUUID = "F0002A19-0451-4000-B000-000000000000".Replace("-", "");
            //DutBatteryDataHandle = "0x00000016";
            //DutBatteryDataNotifiedHandle = "0x00000018";
            //GetCharacteristicsHandle(myCurrentInfo.DeviceCharacteristics, myCurrentInfo.DeviceMeasureRateUUID, out myCurrentInfo.DeviceMeasureRateHandle);

            DisablingNotificationsOrIndications(l_SensorConnectionInfo[index].Address, l_SensorConnectionInfo[index].DutBatteryDataNotifiedHandle, out RespondData);
        }

        public static void GetDeviceBatteryLevel(string TheBatteryDataHex, out int TheBatteryLevel)
        {
            string strValue = TheBatteryDataHex.Substring(0, 2);
            TheBatteryLevel = General.g_Common.GetHexToDec(strValue);
        }

        public static void GetDeviceBatteryStatus(string TheBatteryDataHex, out string TheBatteryStatus)
        {
            //STATUS
            //0x00 Discharging
            //0x01 Charging
            string strValue = TheBatteryDataHex.Substring(2, 2);
            int intValue = General.g_Common.GetHexToDec(strValue);
            if (intValue == 0)
            {
                TheBatteryStatus = "Discharging";
            }
            else
            {
                TheBatteryStatus = "Charging";
            }
        }
        #endregion
        
        public static string PortName = "";
        public static string PortSettings = "";
        public static bool PortIsOpen = false;

        public static string f_PressureUnit = "";
        public static string f_TemperatureUnit = "";

        public TabPage[] SensorTabPages = new TabPage[5];
        public ProgressBar[] SensorBattaryProgressBar = new ProgressBar[5];
        public Chart[] SensorMeasureChart = new Chart[5];
        public ComboBox[] SensorMeasureRate = new ComboBox[5];
        public TextBox[] SensorName = new TextBox[5];

        public frmTest()
        {
            InitializeComponent();

            General.g_Common.SetFormBorderStyle(this, System.Windows.Forms.FormBorderStyle.FixedSingle);
            General.g_Common.SetFormStartPosition(this, FormStartPosition.CenterScreen);
            General.g_Common.SetFormIcon(this, Properties.Resources.Icon);
            General.g_Common.SetControlText(this, General.AssemblyProduct);

            General.g_Common.SetPictureBoxSizeMode(this.ptbLogo, PictureBoxSizeMode.StretchImage);
            General.g_Common.SetPictureBoxImage(this.ptbLogo, Properties.Resources.Logo);

            General.g_Common.SetCheckBoxChecked(this.ckbAutoRange, true);

            #region "StatusStripTool"
            General.g_Common.SetStatusStripSizingGrip(this.stsStatus, false);
            General.g_Common.SetStatusStripToolStripStatusLabelText(this.stsStatus, this.tsslDateTime, DateTime.Now.ToString());
            General.g_Common.SetStatusStripToolStripProgressBarSize(this.stsStatus);
            #endregion

            string[] strData = GetPortNames();
            General.g_Common.SetComboBoxItemsAddRange(this.cbbPortName, strData);
            General.g_Common.SetComboBoxDropDownStyle(this.cbbPortName, ComboBoxStyle.DropDownList);

            strData = GetPortSettings();
            General.g_Common.SetComboBoxItemsAddRange(this.cbbPortSettings, strData);
            General.g_Common.SetComboBoxDropDownStyle(this.cbbPortSettings, ComboBoxStyle.DropDownList);

            strData = General.g_Common.GetPressureUnits();
            General.g_Common.SetComboBoxItemsAddRange(this.cbbPressureUnit, strData);
            General.g_Common.SetComboBoxDropDownStyle(this.cbbPressureUnit, ComboBoxStyle.DropDownList);

            strData = General.g_Common.GetTemperatureUnits();
            General.g_Common.SetComboBoxItemsAddRange(this.cbbTemperatureUnit, strData);
            General.g_Common.SetComboBoxDropDownStyle(this.cbbTemperatureUnit, ComboBoxStyle.DropDownList);

            #region "TabControl"
            SensorTabPages[0] = this.tabPage1;
            SensorTabPages[1] = this.tabPage2;
            SensorTabPages[2] = this.tabPage3;
            SensorTabPages[3] = this.tabPage4;
            SensorTabPages[4] = this.tabPage5;

            SensorBattaryProgressBar[0] = this.pgbData;
            SensorBattaryProgressBar[1] = this.pgbData2;
            SensorBattaryProgressBar[2] = this.pgbData3;
            SensorBattaryProgressBar[3] = this.pgbData4;
            SensorBattaryProgressBar[4] = this.pgbData5;

            General.g_Common.SetTabControlSizeMode(this.tbcSensor, TabSizeMode.Fixed);
            General.g_Common.SetTabPagesClear(this.tbcSensor);
            #endregion

            #region "ComboBox"
            SensorMeasureRate[0] = this.cbbMeasureRate;
            SensorMeasureRate[1] = this.cbbMeasureRate2;
            SensorMeasureRate[2] = this.cbbMeasureRate3;
            SensorMeasureRate[3] = this.cbbMeasureRate4;
            SensorMeasureRate[4] = this.cbbMeasureRate5;

            for (int i = 0; i < 5; i++)
            {
                General.g_Common.SetComboBoxDropDownStyle(SensorMeasureRate[i], ComboBoxStyle.DropDownList);
                General.g_Common.SetControlEnabled(SensorMeasureRate[i], false);
            }
            #endregion

            #region "Textbox"
            SensorName[0] = this.txtSensorName;
            SensorName[1] = this.txtSensorName2;
            SensorName[2] = this.txtSensorName3;
            SensorName[3] = this.txtSensorName4;
            SensorName[4] = this.txtSensorName5;

            for (int i = 0; i < 5; i++)
            {
                General.g_Common.SetControlEnabled(SensorName[i], false);
            }
            #endregion

            #region "Chart"
            SensorMeasureChart[0] = this.chtData;
            SensorMeasureChart[1] = this.chtData2;
            SensorMeasureChart[2] = this.chtData3;
            SensorMeasureChart[3] = this.chtData4;
            SensorMeasureChart[4] = this.chtData5;

            for (int i = 0; i < SensorMeasureChart.Length; i++)
            {
                General.g_Common.SetChartStyle(SensorMeasureChart[i], System.Windows.Forms.DataVisualization.Charting.ChartDashStyle.Solid, Color.Black);
                General.g_Common.SetChartClear(SensorMeasureChart[i]);
            }
            #endregion

            General.g_Common.SetTimerInterval(this, this.tmrDateTime, 1000);
            General.g_Common.SetTimerStart(this, this.tmrDateTime);

            this.ptbLogo.MouseEnter += new EventHandler(General.g_Common.Control_MouseEnterCursor);
            this.ptbLogo.MouseLeave += new EventHandler(General.g_Common.Control_MouseLeaveCursor);
        }

        private void frmTest_Load(object sender, EventArgs e)
        {
            PortName = General.g_Common.GetIniFileRead("System", "PortName", General.g_ConfigIniFilePath);
            PortSettings = General.g_Common.GetIniFileRead("System", "PortSettings", General.g_ConfigIniFilePath);
            f_PressureUnit = General.g_Common.GetIniFileRead("System", "PressureUnit", General.g_ConfigIniFilePath);
            f_TemperatureUnit = General.g_Common.GetIniFileRead("System", "TemperatureUnit", General.g_ConfigIniFilePath);

            General.g_Common.SetControlText(this.cbbPortName, PortName);
            General.g_Common.SetControlText(this.cbbPortSettings, PortSettings);
            General.g_Common.SetControlText(this.cbbPressureUnit, f_PressureUnit);
            General.g_Common.SetControlText(this.cbbTemperatureUnit, f_TemperatureUnit);

            General.g_Common.SetControlEnabled(this.btnStop, false);
            General.g_Common.SetFormShow(this);
        }

        private void frmTest_FormClosing(object sender, FormClosingEventArgs e)
        {
            General.g_Common.SetIniFileWrite("System", "PortName", PortName, General.g_ConfigIniFilePath);
            General.g_Common.SetIniFileWrite("System", "PortSettings", PortSettings, General.g_ConfigIniFilePath);
            General.g_Common.SetIniFileWrite("System", "PressureUnit", f_PressureUnit, General.g_ConfigIniFilePath);
            General.g_Common.SetIniFileWrite("System", "TemperatureUnit", f_TemperatureUnit, General.g_ConfigIniFilePath);

            General.g_Common.SetFormDialogResult(this, System.Windows.Forms.DialogResult.OK);
            General.g_Common.SetFormDispose(this);
        }

        private void frmTest_Resize(object sender, EventArgs e)
        {
            #region "StatusStripTool"
            General.g_Common.SetStatusStripToolStripStatusLabelText(this.stsStatus, this.tsslDateTime, DateTime.Now.ToString());
            General.g_Common.SetStatusStripToolStripProgressBarSize(this.stsStatus);
            #endregion

            #region "TabControl"
            General.g_Common.SetTabControlItemSize(this.tbcSensor);
            #endregion
        }

        private void tmrDateTime_Tick(object sender, EventArgs e)
        {
            General.g_Common.SetStatusStripToolStripStatusLabelText(this.stsStatus, this.tsslDateTime, DateTime.Now.ToString());
            General.g_Common.SetStatusStripToolStripProgressBarSize(this.stsStatus);
        }

        private void cbbPortName_SelectedIndexChanged(object sender, EventArgs e)
        {
            PortName = General.g_Common.GetControlText(this.cbbPortName).Trim();
        }

        private void cbbPortSettings_SelectedIndexChanged(object sender, EventArgs e)
        {
            PortSettings = General.g_Common.GetControlText(this.cbbPortSettings).Trim();
        }

        private void cbbPressureUnit_SelectedIndexChanged(object sender, EventArgs e)
        {
            f_PressureUnit = General.g_Common.GetControlText(this.cbbPressureUnit).Trim();

            if (l_SensorConnectionInfo != null)
            {
                for (int i = 0; i < l_SensorConnectionInfo.Length; i++)
                {
                    double dblPressuerRangeMin = General.g_Common.GetPressureUnitConvert("psi", l_SensorMeasureData[i].MeasurePressureRangeMinPsi, f_PressureUnit);
                    double dblPressuerRangeMax = General.g_Common.GetPressureUnitConvert("psi", l_SensorMeasureData[i].MeasurePressureRangeMaxPsi, f_PressureUnit);
                    General.g_Common.SetChartChartAreaAxisTitle(SensorMeasureChart[i], 0, 1, "Range: " + dblPressuerRangeMin.ToString() + " ~ " + dblPressuerRangeMax.ToString() + " " + f_PressureUnit);

                    for (int j = 0; j < General.g_Common.GetChartSeriesCount(SensorMeasureChart[i]); j++)
                    {
                        General.g_Common.SetChartSeriePointsClear(SensorMeasureChart[i], 0);
                    }
                }
            }
        }

        private void cbbTemperatureUnit_SelectedIndexChanged(object sender, EventArgs e)
        {
            f_TemperatureUnit = General.g_Common.GetControlText(this.cbbTemperatureUnit).Trim();

            if (l_SensorConnectionInfo != null)
            {
                for (int i = 0; i < l_SensorConnectionInfo.Length; i++)
                {
                    General.g_Common.SetChartChartAreaAxisTitle(SensorMeasureChart[i], 1, 1, f_TemperatureUnit);

                    for (int j = 0; j < General.g_Common.GetChartSeriesCount(SensorMeasureChart[i]); j++)
                    {
                        General.g_Common.SetChartSeriePointsClear(SensorMeasureChart[i], 1);
                    }
                }
            }
        }

        private void ckbShowValue_CheckedChanged(object sender, EventArgs e)
        {
            for (int k = 0; k < SensorMeasureChart.Length; k++)
            {
                for (int i = 0; i < General.g_Common.GetChartSeriesCount(SensorMeasureChart[k]); i++)
                {
                    General.g_Common.SetChartSerieIsValueShownAsLabel(SensorMeasureChart[k], i, General.g_Common.GetCheckBoxChecked(this.ckbShowValue));
                }
            }
        }

        bool isStartMeasure = false;
        public void StartMeasure()
        {
            isStartMeasure = false;

            #region "Refresh Window"
            General.g_Common.SetControlCursor(this, Cursors.WaitCursor);

            for (int i = 0; i < 5; i++)
            {
                General.g_Common.SetComboBoxDropDownStyle(SensorMeasureRate[i], ComboBoxStyle.DropDownList);
                General.g_Common.SetControlEnabled(SensorName[i], false);
                General.g_Common.SetControlEnabled(SensorMeasureRate[i], false);
            }
            General.g_Common.SetTabPagesClear(this.tbcSensor);

            for (int k = 0; k < l_SensorConnectionInfo.Length; k++)
            {
                General.g_Common.SetChartClear(SensorMeasureChart[k]);

                General.g_Common.SetChartLegendsCount(SensorMeasureChart[k], 1);
                for (int i = 0; i < General.g_Common.GetChartLegendsCount(SensorMeasureChart[k]); i++)
                {
                    General.g_Common.SetChartLegendFont(SensorMeasureChart[k], i, General.g_FontFamily, General.g_FontSize, FontStyle.Regular);
                }
                General.g_Common.SetChartLegendStyle(SensorMeasureChart[k], 0, System.Windows.Forms.DataVisualization.Charting.Docking.Top, StringAlignment.Center);

                General.g_Common.SetChartChartAreasCount(SensorMeasureChart[k], 2);
                for (int i = 0; i < General.g_Common.GetChartChartAreasCount(SensorMeasureChart[k]); i++)
                {
                    General.g_Common.SetChartChartAreaAxisTitleFont(SensorMeasureChart[k], i, 0, General.g_FontFamily, General.g_FontSize, FontStyle.Regular);
                    General.g_Common.SetChartChartAreaAxisTitleFont(SensorMeasureChart[k], i, 1, General.g_FontFamily, General.g_FontSize, FontStyle.Regular);
                    General.g_Common.SetChartChartAreaAxisInterval(SensorMeasureChart[k], i, 0, System.Windows.Forms.DataVisualization.Charting.DateTimeIntervalType.Number, 1.0);

                    General.g_Common.SetChartChartAreaAxisLabelFont(SensorMeasureChart[k], i, 0, General.g_FontFamily, General.g_FontSize, FontStyle.Regular);
                    General.g_Common.SetChartChartAreaAxisLabelFont(SensorMeasureChart[k], i, 1, General.g_FontFamily, General.g_FontSize, FontStyle.Regular);
                    General.g_Common.SetChartChartAreaAxisLabelFont(SensorMeasureChart[k], i, 3, General.g_FontFamily, General.g_FontSize, FontStyle.Regular);
                    General.g_Common.SetChartChartAreaAxisMajorGridStyle(SensorMeasureChart[k], i, 0, Color.DarkGray);
                    General.g_Common.SetChartChartAreaAxisMajorGridStyle(SensorMeasureChart[k], i, 1, Color.DarkGray);
                    //General.g_Common.SetChartChartAreaAxisMajorGridEnabled(SensorMeasureChart[k], i, 0, false);
                    //General.g_Common.SetChartChartAreaAxisMajorGridEnabled(SensorMeasureChart[k], i, 1, false);
                    General.g_Common.SetChartChartAreaAxisLabelStyleAngle(SensorMeasureChart[k], i, 0, -30);
                }

                General.g_Common.SetChartSeriesCount(SensorMeasureChart[k], 2);
                for (int i = 0; i < General.g_Common.GetChartSeriesCount(SensorMeasureChart[k]); i++)
                {
                    General.g_Common.SetChartSerieChartArea(SensorMeasureChart[k], i, i);
                    //General.g_Common.SetChartSerieBorderWidth(SensorMeasureChart[k], i, 5);

                    General.g_Common.SetChartSerieFont(SensorMeasureChart[k], i, General.g_FontFamily, General.g_FontSize, FontStyle.Regular);
                    //General.g_Common.SetChartSerieShadowOffset(SensorMeasureChart[k], i, 2);

                    General.g_Common.SetChartSerieChartType(SensorMeasureChart[k], i, System.Windows.Forms.DataVisualization.Charting.SeriesChartType.Spline);
                    General.g_Common.SetChartSerieMarkerStyle(SensorMeasureChart[k], i, MarkerStyle.Circle);
                    General.g_Common.SetChartSerieIsValueShownAsLabel(SensorMeasureChart[k], i, General.g_Common.GetCheckBoxChecked(this.ckbShowValue));
                }
                //Pressure
                General.g_Common.SetChartSerieLegendText(SensorMeasureChart[k], 0, "Pressure");

                //Temperature
                General.g_Common.SetChartSerieLegendText(SensorMeasureChart[k], 1, "Temperature");
            }
            #endregion

            for (int i = 0; i < l_SensorConnectionInfo.Length; i++)
            {
                //mac address
                General.g_Common.SetTabPageText(SensorTabPages[i], "Sensor: " + l_SensorConnectionInfo[i].Address);
                General.g_Common.SetTabPagesAdd(this.tbcSensor, SensorTabPages[i]);
                General.g_Common.SetTabControlItemSize(this.tbcSensor);
                General.g_Common.SetControlText(SensorName[i], l_SensorConnectionInfo[i].Name);

                List<string> lstStrData = new List<string>();
                for (uint n = l_SensorMeasureData[i].MeasureRateMin; n <= l_SensorMeasureData[i].MeasureRateMax; n += 100)
                {
                    lstStrData.Add(n.ToString());
                }
                General.g_Common.SetComboBoxItemsClear(SensorMeasureRate[i]);
                General.g_Common.SetComboBoxItemsAddRange(SensorMeasureRate[i], lstStrData.ToArray());
                General.g_Common.SetControlText(SensorMeasureRate[i], l_SensorMeasureData[i].MeasureRate.ToString());

                for (int j = 0; j < General.g_Common.GetChartSeriesCount(SensorMeasureChart[i]); j++)
                {
                    General.g_Common.SetChartSeriePointsClear(SensorMeasureChart[i], j);
                }

                //battery level
                General.g_Common.SetProgressBarValue(SensorBattaryProgressBar[i], l_SensorMeasureData[i].BatteryLevel);

                //pressure
                double dblPressuer = General.g_Common.GetPressureUnitConvert("psi", l_SensorMeasureData[i].MeasurePressurePsi, f_PressureUnit);
                double dblPressureTolerance = General.g_Common.GetPressureUnitConvert("psi", 1.0, f_PressureUnit);
                General.g_Common.SetChartChartAreaAxisRange(SensorMeasureChart[i], 0, 1, dblPressuer - dblPressureTolerance, dblPressuer + dblPressureTolerance);
                General.g_Common.SetChartSeriePointsAddXY(SensorMeasureChart[i], 0, DateTime.Now.ToString("HH:mm:ss"), dblPressuer);

                //pressure unit and range
                double dblPressuerRangeMin = General.g_Common.GetPressureUnitConvert("psi", l_SensorMeasureData[i].MeasurePressureRangeMinPsi, f_PressureUnit);
                double dblPressuerRangeMax = General.g_Common.GetPressureUnitConvert("psi", l_SensorMeasureData[i].MeasurePressureRangeMaxPsi, f_PressureUnit);
                General.g_Common.SetChartChartAreaAxisTitle(SensorMeasureChart[i], 0, 1, "Range: " + dblPressuerRangeMin.ToString() + " ~ " + dblPressuerRangeMax.ToString() + " " + f_PressureUnit);

                //temperature
                double dblTemperature = General.g_Common.GetTemperatureUnitConvert("°C", l_SensorMeasureData[i].MeasureTemperatureC, frmTest.f_TemperatureUnit);
                double dblTemperatureTolerance = General.g_Common.GetTemperatureUnitConvert("°C", 1.0, frmTest.f_TemperatureUnit);
                General.g_Common.SetChartChartAreaAxisRange(SensorMeasureChart[i], 1, 1, dblTemperature - dblTemperatureTolerance, dblTemperature + dblTemperatureTolerance);
                General.g_Common.SetChartSeriePointsAddXY(SensorMeasureChart[i], 1, DateTime.Now.ToString("HH:mm:ss"), dblTemperature);

                //temperature unit
                General.g_Common.SetChartChartAreaAxisTitle(SensorMeasureChart[i], 1, 1, f_TemperatureUnit);

                //start
                string[] strRespondData = { };
                EnabledDeviceBatteryNotified(i, out strRespondData);
                General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);

                EnabledDeviceMeasureDataNotified(i, out strRespondData);
                General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);

                //if (l_SensorMeasureData[i].MeasureRateHex.Length == 24)
                //{
                //    EnabledDeviceMeasureRateNotified(l_SensorConnectionInfo[i].Address, out strRespondData);
                //    General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                //    General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);
                //}
            }

            if (l_SensorConnectionInfo.Length == 1)
            {
                //device name
                if (l_SensorConnectionInfo[0].Characteristics.Length >= 14)
                {
                    General.g_Common.SetControlEnabled(SensorName[0], true);
                }

                //measure rate
                if (l_SensorConnectionInfo[0].Characteristics.Length >= 12)
                {
                    if (frmTest.l_SensorMeasureData[0].MeasureRateHex.Length == 24)
                    {
                        General.g_Common.SetControlEnabled(SensorMeasureRate[0], true);
                    }
                }
            }
            mySerialPort.DataReceived -= new SerialDataReceivedEventHandler(PortDataReceived);
            mySerialPort.DataReceived += new SerialDataReceivedEventHandler(PortDataReceived);
            isStartMeasure = true;

            General.g_Common.SetControlCursor(this, Cursors.Default);
            General.g_Common.SetControlEnabled(this.btnStop, true);
        }

        public void ChangeDeviceName()
        {
            if (isStartMeasure)
            {
                General.g_Common.SetControlCursor(this, Cursors.WaitCursor);
                General.g_IsChangeDeviceName = true;

                mySerialPort.DiscardInBuffer();
                mySerialPort.DiscardOutBuffer();

                string[] strRespondData = { };
                string strUnitName = _SensorName;
                frmTest.SetDeviceName(0, strUnitName, out strRespondData);
                General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);
                frmTest.l_SensorMeasureData[0].Name = _SensorName;

                General.g_IsChangeDeviceName = false;
                General.g_Common.SetControlCursor(this, Cursors.Default);
            }
        }

        public void ChangeMeasureRate()
        {
            if (isStartMeasure)
            {
                General.g_Common.SetControlCursor(this, Cursors.WaitCursor);
                General.g_IsChangeMeasureRate = true;

                //for (int i = 0; i < l_SensorConnectionInfo.Length; i++)
                //{
                    mySerialPort.DiscardInBuffer();
                    mySerialPort.DiscardOutBuffer();

                    if (frmTest.l_SensorMeasureData[0].MeasureRateHex.Length == 24)
                    {
                        string[] strRespondData = { };
                        string strValue = General.g_Common.GetControlText(SensorMeasureRate[0]);
                        uint MeasureRate = 0;
                        uint.TryParse(strValue, out MeasureRate);
                        byte[] bytData = General.g_Common.GetUInt32ToByte(MeasureRate);
                        string strNewSource = "";
                        List<string> lstStrData = new List<string>();
                        for (int j = 0; j < bytData.Length; j++)
                        {
                            strNewSource += bytData[j].ToString("X2");
                        }
                        strNewSource += l_SensorMeasureData[0].MeasureRateHex.Substring(8);

                        SetDeviceMeasureRate(0, strNewSource, out strRespondData);
                        frmTest.l_SensorMeasureData[0].MeasureRate = MeasureRate;
                        General.g_Common.SetListBoxItemsAddRange(this.lsbLog, strRespondData);
                        General.g_Common.SetListBoxSelectedIndex(this.lsbLog, General.g_Common.GetListBoxItemsCount(this.lsbLog) - 1);
                    }
                //}

                General.g_IsChangeMeasureRate = false;
                General.g_Common.SetControlCursor(this, Cursors.Default);
            }
        }
        
        private void btnScan_Click(object sender, EventArgs e)
        {
            General.g_Common.SetControlCursor(this, Cursors.WaitCursor);

            PortName = General.g_Common.GetControlText(this.cbbPortName).Trim();
            PortSettings = General.g_Common.GetControlText(this.cbbPortSettings).Trim();

            bool bolValue = false;
            if (PortIsOpen)
            {
                mySerialPort.DataReceived -= new SerialDataReceivedEventHandler(PortDataReceived);
                mySerialPort.DiscardInBuffer();
                mySerialPort.DiscardOutBuffer();

                bolValue = ClosePort();
                if (bolValue)
                {
                    PortIsOpen = false;
                }
            }

            if (!PortIsOpen)
            {
                bolValue = OpenPort(PortName, PortSettings);
                if (bolValue)
                {
                    PortIsOpen = true;
                }

                if (!PortIsOpen)
                {
                    string strCaption = string.Empty;
                    string strMessage = string.Empty;
                    if (General.g_Language.ToUpper() == "Chinese".ToUpper())
                    {
                        strCaption = "错 误";
                        strMessage = "打开端口：" + PortName + " 错误！";
                    }
                    else
                    {
                        strCaption = "Error";
                        strMessage = "Open port name :" + PortName + " error !";
                    }
                    General.g_Common.SetMessageBoxShow(strMessage, strCaption, MessageBoxIcon.Error);
                    General.g_Common.SetControlCursor(this, Cursors.Default);
                    return;
                }
            }

            General.g_Common.SetControlEnabled(this.btnScan, false);

            frmScan frmForm = new frmScan();
            DialogResult RtnResult = frmForm.ShowDialog();
            if (RtnResult == DialogResult.OK)
            {
                General.g_Common.SetThreadStart(StartMeasure);
            }
            else
            {
                General.g_Common.SetControlCursor(this, Cursors.Default);
                General.g_Common.SetControlEnabled(this.btnScan, true);
            }    
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            General.g_IsUserTerminate = true;
            General.g_Common.SetControlEnabled(this.btnStop, false);
            General.g_Common.SetControlCursor(this, Cursors.WaitCursor);
        }

        private void ptbLogo_MouseClick(object sender, MouseEventArgs e)
        {
            frmAbout frmForm = new frmAbout();
            General.g_Common.SetFormShowDialog(frmForm);
        }

        string _SensorName = "";
        private void txtSensorName_TextChanged(object sender, EventArgs e)
        {            
            _SensorName = General.g_Common.GetControlText(this.txtSensorName);
            if (_SensorName.Length > 18)
            {
                _SensorName = _SensorName.Substring(0, 18);
            }
        }

        private void txtSensorName_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
            {
                ChangeDeviceName();
                General.g_Common.SetControlFocus(this.btnStop);
            }
        }

        private void cbbMeasureRate_SelectedIndexChanged(object sender, EventArgs e)
        {
            ChangeMeasureRate();
            General.g_Common.SetControlFocus(this.btnStop);
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            General.g_Common.SetFormClose(this);
            General.g_Common.SetApplicationExit();
        }

        private void btnAbout_Click(object sender, EventArgs e)
        {
            frmAbout frmForm = new frmAbout();
            General.g_Common.SetFormShowDialog(frmForm);
        }


    }
}
